; Definition of typed pairs, Application chapter
; By Nils M Holm, 2016
;
; Provided under the Creative Common Zero (CC0) license
; (https://creativecommons.org/publicdomain/zero/1.0/)
;
; From the book COMPILING LAMBDA CALCULUS, http://t3x.org/clc/
;
; Based on http://matt.might.net/articles/compiling-up-to-lambda-calculus/

; Examples: (kar ((kons 'a) 'b))
;           (kdr ((kons 'a) 'b))
;           (((nullp nil) #t) #f)
;           (((konsp ((kons 'a) 'b)) #t) #f)

(define true
  (lambda (x)
    (lambda (y)
      x)))

(define false
  (lambda (x)
    (lambda (y)
      y)))

(define kons
  (lambda (x) 
    (lambda (y)
      (lambda (fcons)
        (lambda (fnil)
          ((fcons x) y))))))

(define nil
  (lambda (fcons)
    (lambda (fnil)
      (fnil (lambda (x) x)))))

(define kar
  (lambda (k)
    ((k (lambda (x) (lambda (y) x)))
     (lambda (_) nil))))

(define kdr
  (lambda (k)
    ((k (lambda (x) (lambda (y) y)))
     (lambda (_) nil))))

(define konsp
  (lambda (k)
    ((k (lambda (_) (lambda (_) true)))
     (lambda (_) false))))

(define nullp
  (lambda (k)
    ((k (lambda (_) (lambda (_) false)))
     (lambda (_) true))))
