; Schematic recursion operator, Scheme version
; By Nils M Holm, 2016
;
; Provided under the Creative Common Zero (CC0) license
; (https://creativecommons.org/publicdomain/zero/1.0/)
;
; From the book COMPILING LAMBDA CALCULUS, http://t3x.org/clc/

; Requires low-level macros (DEFINE-MACRO)

; Example: ((rec (lambda (x)
;                  (if (zero? x)
;                      1
;                      (* x (r (- x 1))))))
;           10)

(define-macro (rec F)
  `((lambda (r)
     ((lambda (t)
        (set! r t)
        r)
      ,F))
    (lambda (x) x)))

